//
// hello.button-blink.RP2040.1.ino
//
// Seeed XIAO RP2040 button, blink, echo hello-world, single core
//
// Neil Gershenfeld 12/28/23
//
// This work may be reproduced, modified, distributed,
// performed, and displayed for any purpose, but must
// acknowledge this project. Copyright is retained and
// must be preserved. The work is provided as is; no
// warranty is provided, and users accept all liability.
//
// add RP2040 core
//    https://github.com/earlephilhower/arduino-pico
//
#define led_pin 1
#define button_pin 27

void setup() {
   pinMode(led_pin, OUTPUT);
   pinMode(button_pin, INPUT); // Changed to INPUT from INPUT_PULLUP
   Serial.begin(9600); // Initialize serial communication at 9600 bits per second
   Serial.setTimeout(10); // Set serial timeout to 10 milliseconds
}

bool button_up = true; // Track if the button is released

void loop() {
   if (Serial.available()) { // Check if data is available to read from the serial port
      digitalWrite(led_pin, HIGH); // Turn on the LED
      String s = Serial.readString(); // Read the incoming string
      Serial.print("you typed: ");
      Serial.println(s); // Print the string to the Serial Monitor
      delay(100); // Wait for 100 milliseconds
      digitalWrite(led_pin, LOW); // Turn off the LED
   }
   if (digitalRead(button_pin) == HIGH && button_up) { // If button is pressed (input is HIGH because of the pull-down resistor)
      digitalWrite(led_pin, HIGH); // Turn on the LED
      Serial.println("button down"); // Print "button down" to the Serial Monitor
      button_up = false; // Mark the button as pressed
   }
   else if (digitalRead(button_pin) == LOW && !button_up) { // If button is released (input is LOW)
      digitalWrite(led_pin, LOW); // Turn off the LED
      Serial.println("button up"); // Print "button up" to the Serial Monitor
      button_up = true; // Reset the button state to released
   }
}
